unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, ComCtrls;

type

  { TForm1 }
  
  Jobs = record
    jfrom,jto,name:string;
    filesize:int64;
    status:char;
    exists:boolean; //WDECP
   end;

  TForm1 = class(TForm)
    btn_start: TButton;
    btn_stop: TButton;
    btn_del: TButton;
    btn_add: TButton;
    btn_up: TButton;
    btn_down: TButton;
    btn_skip: TButton;
    btn_tstat: TButton;
    job_info: TStaticText;
    odlg: TOpenDialog;
    sdlg: TSaveDialog;
    txt_skip: TEdit;
    Label4: TLabel;
    prog: TProgressBar;
    info: TStaticText;
    txt_from: TEdit;
    txt_to: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    task_group: TGroupBox;
    Label1: TLabel;
    task_list: TListBox;
    procedure btn_addClick(Sender: TObject);
    procedure btn_delClick(Sender: TObject);
    procedure btn_downClick(Sender: TObject);
    procedure btn_skipClick(Sender: TObject);
    procedure btn_startClick(Sender: TObject);
    procedure btn_stopClick(Sender: TObject);
    procedure btn_tstatClick(Sender: TObject);
    procedure btn_upClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure task_listClick(Sender: TObject);
  private
    { private declarations }
    procedure showmsg(s: string);
    procedure updtask;
    procedure updlist;
    procedure deltask(num:integer);
    procedure savecfg;
    procedure loadcfg;
    procedure copyf(num:integer);
  public
    { public declarations }
  end; 

var
  Form1: TForm1;
  exedir:string;
  cj: array [0..49] of Jobs;
  str_len:smallint;
  str_char:array [0..4096] of char;
  cop,cancel:boolean;

implementation

procedure StC(str:string);
var n:integer;
begin
 for n:=1 to length(str) do str_char[n-1]:=str[n];
 str_len:=length(str);
end;

function CtS(len:smallint):string;
var
 n:integer;
 s:string;
begin
 s:='';
 for n:=0 to len-1 do s:=s+str_char[n];
 CtS:=s;
 s:='';
end;

function GetFileSize(filename:string): int64;
var
 f:file;
begin
 {$I-}
 FileMode:=0;
 assignfile(f,filename);
 reset(f,1);
 GetFileSize:=filesize(f);
 closefile(f);
 if IOResult<>0 then GetFileSize:=-1;
 FileMode:=2;
 {$I+}
end;

function GetStatus(jobn:integer): string;
var t:string;
begin
 t:=cj[jobn].status;
 if t='W' then t:=' ' else
  if t='D' then t:='' else
   if t='E' then t:='' else
    if t='C' then t:='' else
     if t='P' then t:='';
 GetStatus:=t;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 n,m:integer;
 t:string;
begin
 t:=paramstr(0);
 for n:=length(t) downto 1 do
  if (t[n]='/') or (t[n]='\') then
   begin
    m:=n;
    break;
   end;
 exedir:='';
 for n:=1 to m-1 do
  exedir:=exedir+t[n];
 t:='';
 for n:=0 to 49 do cj[n].exists:=false;
 showmsg('Copier   '+exedir);
 cop:=false;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 savecfg;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
 loadcfg;
 updtask;
end;

procedure TForm1.btn_addClick(Sender: TObject);
var
 n,j,m:integer;
begin
 j:=-1;
 for n:=0 to 49 do
  if not cj[n].exists then
   begin
    j:=n;
    break;
   end;
 if (j<0) or (j>49) then
  begin
   showmsg('Tasks list overflow!');
   exit;
  end;
 if odlg.Execute then cj[j].jfrom:=odlg.FileName;
 if not fileexists(cj[j].jfrom) then exit;
 cj[j].filesize:=GetFileSize(cj[j].jfrom);
 if (cj[j].filesize<1) then exit;
 m:=1;
 for n:=length(cj[j].jfrom) downto 1 do
  if (cj[j].jfrom[n]='/') or (cj[j].jfrom[n]='\') then
   begin
    m:=n;
    break;
   end;
 cj[j].name:='';
 for n:=m+1 to length(cj[j].jfrom) do
  cj[j].name:=cj[j].name+cj[j].jfrom[n];
 sdlg.FileName:=cj[j].name;
 if sdlg.Execute then cj[j].jto:=sdlg.FileName else exit;
 if (cj[j].jfrom=cj[j].jto) then exit;
 cj[j].status:='W';
 cj[j].exists:=true;
 updlist;
end;

procedure TForm1.btn_delClick(Sender: TObject);
begin
 deltask(task_list.ItemIndex);
end;

procedure TForm1.btn_downClick(Sender: TObject);
var
 n:integer;
 tj:Jobs;
begin
 cancel:=true;
 n:=task_list.ItemIndex;
 if (n<0) or not cj[n].exists or not cj[n+1].exists then exit;
 tj:=cj[n];
 cj[n]:=cj[n+1];
 cj[n+1]:=tj;
 if (cj[n].status='P') then cj[n].status:='W';
 if (cj[n+1].status='P') then cj[n+1].status:='W';
 updlist;
 task_list.ItemIndex:=n+1;
 updtask;
end;

procedure TForm1.btn_skipClick(Sender: TObject);
var
 n,m:integer;
 f:file;
 fs:int64;
 s:longint;
 c:byte;
begin
 n:=task_list.ItemIndex;
 if (n<0) then exit;
 if not cj[n].exists or (cj[n].status<>'E') then exit;
 if not fileexists(cj[n].jto) then exit;
 s:=strtoint(txt_skip.Text);
 if (s<1) then
  begin
   showmsg('  !');
   exit;
  end;
 {$I-}
 assignfile(f,cj[n].jto);
 reset(f,1);
 fs:=filesize(f);
 if (IOresult<>0) or (fs<0) then
  begin
   closefile(f);
   IOResult;
   showmsg('  !');
   exit;
  end;
 seek(f,fs);
 if (fs+s>cj[n].filesize) then s:=cj[n].filesize-fs;
 c:=0;
 for m:=1 to s do
  begin
   blockwrite(f,c,1);
   if (IOResult<>0) then break;
  end;
 s:=filesize(f)-fs;
 closefile(f);
 IOResult;
 {$I+}
 if (getfilesize(cj[n].jto)>=cj[n].filesize) then
  begin
   showmsg('   !');
   cj[n].status:='D';
  end else showmsg(' '+inttostr(s)+' .');
 updlist;
 updtask;
end;

procedure TForm1.btn_startClick(Sender: TObject);
var
 n,m:integer;
begin
 if cop then exit;
 cancel:=false;
 while true do
  begin
   m:=-1;
   for n:=0 to 49 do
    if cj[n].exists and (cj[n].status='W') then
     begin
      m:=n;
      break;
     end;
   if (m>=0) then copyf(m) else
    begin
     showmsg('');
     break;
    end;
   if cancel then
    begin
     cancel:=false;
     showmsg('');
     break;
    end;
  end;
 updlist;
 updtask;
end;

procedure TForm1.btn_stopClick(Sender: TObject);
begin
 cancel:=true;
end;

procedure TForm1.btn_tstatClick(Sender: TObject);
var
 n:integer;
 s:char;
begin
 n:=task_list.ItemIndex;
 if (n<0) then exit;
 if not cj[n].exists then exit;
 s:=cj[n].status;
 if (s='W') or (s='P') then cj[n].status:='C' else
  if (s='E') or (s='C') then cj[n].status:='W' else
   if (s='D') then deltask(n);
 if (s<>'D') then updlist;
end;

procedure TForm1.btn_upClick(Sender: TObject);
var
 n:integer;
 tj:Jobs;
begin
 cancel:=true;
 n:=task_list.ItemIndex;
 if (n<1) or not cj[n].exists then exit;
 tj:=cj[n];
 cj[n]:=cj[n-1];
 cj[n-1]:=tj;
 if (cj[n].status='P') then cj[n].status:='W';
 if (cj[n-1].status='P') then cj[n-1].status:='W';
 updlist;
 task_list.ItemIndex:=n-1;
 updtask;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
 cancel:=true;
end;

procedure TForm1.task_listClick(Sender: TObject);
begin
  updtask;
end;

procedure TForm1.showmsg(s: string);
begin
 info.Caption:=s;
end;

procedure TForm1.updtask;
var
 n:integer;
 fs:int64;
begin
 txt_from.Enabled:=false;
 txt_to.Enabled:=false;
 txt_from.Text:='';
 txt_to.Text:='';
 btn_skip.Enabled:=false;
 btn_tstat.Caption:='';
 btn_tstat.enabled:=false;
 job_info.Caption:='';
 n:=task_list.ItemIndex;
 if (n<0) or not cj[n].exists then exit;
 txt_from.Enabled:=true;
 txt_to.Enabled:=true;
 txt_from.Text:=cj[n].jfrom;
 txt_to.Text:=cj[n].jto;
 fs:=GetFileSize(cj[n].jto);
 if (fs>=cj[n].filesize) then cj[n].status:='D';
 if (fs>=0) then
  begin
   job_info.text:=' '+inttostr(fs div 1024)+'  '+inttostr(cj[n].filesize div 1024)+
    '  ('+inttostr(round(fs/cj[n].filesize*100))+'%, '+GetStatus(n)+')';
  end else job_info.Caption:='    ('+GetStatus(n)+')';
 if (cj[n].status='E') then btn_skip.Enabled:=true;
 if (cj[n].status='W') or (cj[n].status='P') then btn_tstat.Caption:=''
  else if (cj[n].status='C') or (cj[n].status='E') then btn_tstat.Caption:=''
   else if (cj[n].status='D') then btn_tstat.Caption:='';
 btn_tstat.enabled:=true;
end;

procedure TForm1.updlist;
var
 n,m:integer;
begin
 m:=task_list.ItemIndex;
 task_list.Clear;
 for n:=0 to 49 do
  begin
   if not cj[n].exists then break;
   task_list.Items.Add(cj[n].name+' ('+inttostr(cj[n].filesize div 1024)+
    ' Kb) - '+GetStatus(n));
  end;
 if (m>task_list.Count-1) then m:=task_list.Count-1;
 task_list.ItemIndex:=m;
 updtask;
end;

procedure TForm1.deltask(num:integer);
var
 n,m:integer;
begin
 if (num<0) or (num>49) then exit;
 if not cj[num].exists then exit;
 m:=49;
 cancel:=true;
 for n:=0 to 49 do
  if not cj[n].exists then
   begin
    m:=n-1;
    break;
   end;
 for n:=num to m-1 do cj[n]:=cj[n+1];
 cj[m].exists:=false;
 updlist;
end;

procedure TForm1.savecfg;
var
 n:integer;
 f:file;
 i:smallint;
begin
 assignfile(f,exedir+'\copier.cfg');
 rewrite(f,1);
 i:=12345;
 blockwrite(f,i,2);
 i:=form1.Top;
 blockwrite(f,i,2);
 i:=form1.Left;
 blockwrite(f,i,2);
 for n:=0 to 49 do if not cj[n].exists then
  begin
   i:=n-1;
   break;
  end;
 blockwrite(f,i,2);
 for n:=0 to i do
  begin
   StC(cj[n].name);
   blockwrite(f,str_len,2);
   blockwrite(f,str_char,str_len);
   StC(cj[n].jfrom);
   blockwrite(f,str_len,2);
   blockwrite(f,str_char,str_len);
   StC(cj[n].jto);
   blockwrite(f,str_len,2);
   blockwrite(f,str_char,str_len);
   blockwrite(f,cj[n].filesize,sizeof(int64));
   blockwrite(f,cj[n].status,1);
  end;
 closefile(f);
end;

procedure TForm1.loadcfg;
var
 f:file;
 i:smallint;
 n:integer;
begin
 for n:=0 to 49 do cj[n].exists:=false;
 if not fileexists(exedir+'\copier.cfg') then exit;
 assignfile(f,exedir+'\copier.cfg');
 reset(f,1);
 blockread(f,i,2);
 if (i<>12345) then begin closefile(f); showmsg('  '); exit; end;
 blockread(f,i,2);
 form1.Top:=i;
 blockread(f,i,2);
 form1.Left:=i;
 blockread(f,i,2);
 if (i<0) or (i>49) then begin closefile(f); exit; end;
 for n:=0 to i do
  begin
   blockread(f,str_len,2);
   blockread(f,str_char,str_len);
   cj[n].name:=CtS(str_len);
   blockread(f,str_len,2);
   blockread(f,str_char,str_len);
   cj[n].jfrom:=CtS(str_len);
   blockread(f,str_len,2);
   blockread(f,str_char,str_len);
   cj[n].jto:=CtS(str_len);
   blockread(f,cj[n].filesize,sizeof(int64));
   blockread(f,cj[n].status,1);
   cj[n].exists:=true;
  end;
 closefile(f);
 updlist;
end;

procedure TForm1.copyf(num:integer);
var
 n:integer;
 fi,fo:file;
 fis,fos:int64;
 buf:array [0..8191] of byte;
begin
 if not cj[num].exists then exit;
 if not fileexists(cj[num].jfrom) then
  begin
   cj[num].status:='E';
   exit;
  end;
 cop:=true;
 cj[num].status:='P';
 updlist;
 updtask;
 Application.ProcessMessages;
 FileMode:=0;
 {$I-}
 assignfile(fi,cj[num].jfrom);
 reset(fi,1);
 fis:=filesize(fi);
 if (IOResult<>0) or (fis<1) then
  begin
   closefile(fi);
   cj[num].status:='E';
   cop:=false;
   IOresult;
   exit;
  end;
 FileMode:=2;
 assignfile(fo,cj[num].jto);
 if not fileexists(cj[num].jto) then
  begin
   rewrite(fo,1);
   closefile(fo);
  end;
 if (IOResult<>0) then
  begin
   closefile(fi);
   closefile(fo);
   cj[num].status:='E';
   cop:=false;
   IOresult;
   exit;
  end;
 while true do
  begin
   if not fileexists(cj[num].jto) then
    begin
     cj[num].status:='E';
     break;
    end;
   IOResult;
   if cancel then
    begin
     if (cj[num].status='P') then cj[num].status:='W';
     break;
    end;
   if (cj[num].status<>'P') then break;
   reset(fo,1);
   fos:=filesize(fo);
   seek(fo,fos);
   if (fos>=fis) then
    begin
     cj[num].status:='D';
     break;
    end;
   FileMode:=0;
   seek(fi,fos);
   blockread(fi,buf,8192,n);
   FileMode:=2;
   if (IOResult=0) then blockwrite(fo,buf,n) else
    begin
     cj[num].status:='E';
     break;
    end;
   closefile(fo);
   n:=round(fos/fis*100);
   prog.Position:=n;
   showmsg(': '+inttostr(fos div 1024)+' / '+inttostr(fis div 1024)+' Kb ('+inttostr(n)+'%)');
   Application.ProcessMessages;
  end;
 closefile(fi);
 closefile(fo);
 IOresult;
 {$I+}
 cop:=false;
 prog.Position:=0;
 showmsg(' , : '+GetStatus(num));
 updlist;
 updtask;
 Application.ProcessMessages;
end;

initialization
  {$I unit1.lrs}

end.

